 '**************************************
' "VclLister.bas"
'Purpose:
'Decompile Delphi VCL resources. Each VCL resource defines a
'single dialog.

'Notes:
'The VCL data types might not be accurately represented, since no
'documentation was available. The listings generated agree very
'well with those from other resource dumpers.
'It appears that a single NULL marks the end of an object's
'properties, and two NULLs mark the end of an object.
'Some parameters such as for "Font.Height" are negative values.
'They correspond to height values normally passed to "CreateFont"
'These values also agree with the listings from other dumper's.
'You can change the output file's extension by modifying "$OutExt"
'TheirCorp doesn't have PBCC, and so can't test the PBCC-specific
'code.
'This was written in the course of developing TheirCorp's clone of
'"KeyNote" called "TheirNote". KeyNote was written in Delphi.
'TheirCorp's VCL-related code is expected to also contribute well
'to other sub-projects of TheirCorp's "IdeaTester" project:
'"BinEditPlus" --- a decompiler for EXE, DLL and other PE format files
'This is to be as complete as reasonably possible, so VCL handling is
'a good addition.
'"WinClone" --- clones other GUI's by mouse-over like PBWinSpy++++,
'and also by translating resource data, such as VCL. Decompiling VCL
'data is needed to get:
'* Tooltips "Hints" --- Tooltips are otherwise hard to obtain, because
' sometimes they are only sent to the tooltip control when requested.
'* ListBox and ComboBox contents --- These are often included in the VCL
' data. These can also be obtained by mouse-over techniques if the
' controls aren't too low in a window hierarchy.
'* Information about any controls which are too low in a window hierarchy.
' (nothing has been posted about WinClone yet)
'"SetMan" --- a settings management solution, will use some of WinClone's
'functionality to get information about GUI's and use it to automatically
'generate INI files for it.
' (nothing has been posted about SetMan yet)
'**************************************
#Compile Exe "VclLister.exe"
#Dim All
#Register All
'#Debug Error On
#Tools Off
'you can change the output file's extension here
$OutExt = ".txt"
$InFile = "RCData.bin"
$FormID = "TPF0"
%LenFormID = 4 '= Len($FormID)
$EndObject = $Nul & $Nul
%Typ_Object = 0&
%Typ_Items = 1&
%Typ_sByte = 2&
%Typ_Word = 3&
%Typ_Dword = 4& '(assumed unsigned)
%Typ_Extended = 5&
%Typ_sString = 6& 'short string
%Typ_Named = 7&
%Typ_False = 8&
%Typ_True = 9&
%Typ_lString = 10& 'long string
%Typ_List = 11&
%Typ_Array = 14&
$About = "VCL Lister - A Decompiler for Delphi VCL resources, by TheirCorp."
'**************************************
' Macros
'If your compiler version doesn't support
'macros, use your editor's "replace-all"
'feature.
Macro GetStr = GoSub GetString 'macro to call "GetString"
Macro GetType = GoSub GetTypeCode 'macro to call "GetTypeCode"
'**************************************
Global bs As String 'binary data
Global fs As String 'file names
'**************************************
Sub Msg(ps As String)
    #If %Def(%Pb_Cc32)
    Print $About
    Print ps
    #Else
    MsgBox ps, , $About
    #EndIf
End Sub 'Msg
'**************************************
Function DeVCL(ByVal typ As Long) As Long
    Static ff As Long
    Static d As Dword
    Static n As Long
    Static p As Long
    Static v As Long
    Static nEnd As Long
    Static nLvl As Long 'level of recursion
    'these control the printing at the end of the function
    Static fPrint As Long 'print-enable
    Static fEqual As Long 'print " = "
    Static fTabs As Long 'indent results
    Static ls As String
    Static ts As String
    Static nTabs As Long 'TABs for indenting

    Function = 1 'preset to error value
    '--------------------------------------
    ' level-dependent code
    '--------------------------------------
    If nLvl = 0 Then 'first time through
    '--------------------------------------
    ' check for ID string
    '--------------------------------------
    If Left$(bs, %LenFormID) <> $FormID Then
    Msg "Error:" & $CrLf & fs & $CrLf & "...is an invalid file."
    Exit Function
    End If
    p = %LenFormID + 1 'advance past ID string
    nEnd = Len(bs) - 3
    Incr fPrint
    Incr fEqual
    '--------------------------------------
    ' open output file
    '--------------------------------------
    Try
    ff = FreeFile
    fs = Mid$(fs, InStr(-1, fs, "\") + 1)
    fs = Extract$(fs, ".") & $OutExt
    Open fs For Output As #ff
    Print# ff, $About
    Catch
    Msg "Error " & Format$(Err) & " when opening: """ & fs & """"
    End Try
    End If
    Incr nLvl
    '--------------------------------------
    ' decode objects
    '--------------------------------------
    If typ = %Typ_Object Then 'enumerate child objects
    'Format: <00>...object's properties and child objects...
    '--------------------------------------
    ' get the object's class
    '--------------------------------------
    GetStr
    If Len(ls) = 0 Then Exit If
    Print# ff,
    Print# ff, String$(nTabs, $Tab) & "object " & ls & ":";
    '--------------------------------------
    ' get the object's name
    '--------------------------------------
    GetStr
    Print# ff, ls
    '--------------------------------------
    ' get the object's properties
    '--------------------------------------
    Do While p <= nEnd
    If Asc(bs, p) Then 'found a property's name
    GetStr
    Incr nTabs
    Print# ff, String$(nTabs, $Tab) & ls;
    GetType
    If DeVcl(typ) Then Exit Function
    Decr nTabs
    Else 'end of the object's properties
    Exit Do
    End If
    Loop
    '--------------------------------------
    ' get child objects, if any
    '--------------------------------------
    Do Until Mid$(bs, p, 2) = $EndObject
    If Asc(bs, p) = 0 Then 'a child object
    Incr p
    Incr nTabs
    If DeVcl(%Typ_Object) Then Exit Function
    Print# ff, String$(nTabs, $Tab) & "end"
    Decr nTabs
    End If
    Loop While p <= nEnd
    ls = ""
    Incr p
    ElseIf typ = %Typ_Items Then 'list of data items terminated by a NULL entry
    'this needs to format the output based on the type of object property
    'this data is for: ComboBox items versus Statusbar panels for example.
    If Right$(ls, 8) = ".Strings" Then
    'Format for ComboBox items:
    '<01><06><Len1><data1>, <06><Len2><data2>... <00>
    fEqual = 0
    Incr fTabs
    Print# ff, " = ("
    Do While p <= nEnd
    GetType
    If typ Then
    Incr nTabs
    If DeVcl(typ) Then Exit Function
    Decr nTabs
    End If
    Loop While typ
    Print# ff, ")"
    Incr fEqual
    fTabs = 0
    Else '"Panels" ?
    'Format for statusbar panel:
    '<01><Len1><Prop1><Typ1><Param1>, <Len2><Prop2><Typ2><Param2>... <00>
    Print# ff, String$(nTabs, $Tab) & "item"
    Incr nTabs
    Do While p <= nEnd
    GetStr
    If Len(ls) Then
    Print# ff, String$(nTabs, $Tab) & ls;
    GetType
    If DeVcl(typ) Then Exit Function
    End If
    Loop While Len(ls)
    Decr nTabs
    Print# ff, String$(nTabs, $Tab) & "end"
    End If
    ls = ""
    ElseIf typ = %Typ_sByte Then 'signed byte
    'Format: <02><byte>
    v = Asc(bs, p)
    If v > 127 Then v = &HFFFFFF00& Or v 'sign-extend the value
    ls = Format$(v)
    Incr p
    ElseIf typ = %Typ_Word Then 'word (signed or unsigned?)
    'Format: <03><Word>
    ls = Format$(CvWrd(bs, p))
    p = p + 2
    ElseIf typ = %Typ_Dword Then '32-bit value (signed or unsigned?)
    'Format: <04><DWord>
    ls = Format$(CvDwd(bs, p))
    p = p + 4
    ElseIf typ = %Typ_Extended Then 'extended precision value (10-bytes)
    'Format: <05><Ext>
    ls = Format$(Cve(bs, p))
    p = p + 10
    ElseIf typ = %Typ_sString Then 'short string preceded by the one-byte length value
    'Format: <06><len>"Short String"
    GetStr
    ElseIf typ = %Typ_Named Then 'named value
    'Format: <07><len>"Short String"
    GetStr
    ElseIf typ = %Typ_False Then 'one-byte Boolean false
    'Format: <08>(nothing follows)
    ls = "False"
    ElseIf typ = %Typ_True Then 'one-byte Boolean true
    'Format: <09>(nothing follows)
    ls = "True"
    ElseIf typ = %Typ_lString Then 'a long string, beginning with 32-bit length value
    'Format: <0A><len>"Long String..."
    d = CvDwd(bs, p)
    p = p + 4
    ls = Mid$(bs, p, d)
    p = p + d

    'print data in hex format
    Print# ff, "{";
    Incr nTabs
    For n = 1 To Len(ls)
    If (n - 1) Mod 32 = 0 Then 'new line
    Print# ff,
    Print# ff, String$(nTabs, $Tab);
    End If
    Print# ff, Hex$(Asc(ls, n), 2);
    Next n
    Print# ff, "}"
    Decr nTabs
    ls = ""
    ElseIf typ = %Typ_List Then 'list of one or more short strings terminated by a zero-length string
    'Format: <0B><len1>"String1"<len2>"String2"...<00>
    ts = "["
    Do While p <= nEnd
    GetStr
    ts = ts & ls & ", "
    Loop While Len(ls)
    ls = RTrim$(ts, Any ", ") & "]"
    ElseIf typ = %Typ_Array Then 'an array of multi-type property groups ?
    'each element ends with a NULL entry and the array itself
    'ends with two NULL entries.
    'Format: <0E><Len1><Name1><Type1><Data1>, <Len2><Name2><Type2><Data2>... <00>
    'used to define statusbar panels, for example
    Print# ff, " = <"
    Do While p <= nEnd
    GetType
    If typ Then
    Incr nTabs
    Print# ff,
    Print# ff, String$(nTabs, $Tab) & "item"
    Incr nTabs
    If DeVcl(typ) Then Exit Function
    Decr nTabs
    Print# ff, String$(nTabs, $Tab) & "end";
    Decr nTabs
    End If
    Loop While typ
    Print# ff, ">"
    Else
    Print# ff,
    Print# ff, "Decoding Error: "
    Print# ff, "Couldn't recognize code:" & Str$(typ) & " at offset:" & Str$(p)
    Exit Function 'don't let the error value get cleared
    End If
    If Min&(fPrint, Len(ls)) Then
    If fTabs Then Print# ff, String$(nTabs, $Tab);
    If fEqual Then Print# ff, " = ";
    Print# ff, ls
    End If
    '--------------------------------------
    ' level-dependent exit code
    '--------------------------------------
    Decr nLvl
    If nLvl = 0 Then 'final exit
    For nTabs = nTabs To 0 Step -1
    Print# ff, String$(nTabs, $Tab) & "end"
    Next nTabs
    Close# ff
    Reset bs : Reset fs : Reset ls : Reset ts
    End If
    If p <= Len(bs) Then Function = 0 'clear the previously set error value
    Exit Function ' don't run into the local subs
    '---------------------------------------
    'GetTypeCode:
    ' Get the next data type code
    '---------------------------------------
    GetTypeCode:
    typ = Asc(bs, p) 'get the parameter-type code
    Incr p 'advance past the parameter-type code
    Return
    '---------------------------------------
    'GetStr:
    ' Get a string in the format: <len>"String"
    ' where "len" is a one-byte value
    '---------------------------------------
    GetString:
    n = Asc(bs, p) 'get length
    ls = Mid$(bs, p + 1, n) 'get the string
    p = p + n + 1 'advance p past the string
    Return
End Function 'DeVCL
'**************************************


Function PBMain
    Local ff As Long
    fs = Command$
    If Len(fs) = 0 Then fs = $InFile
    '--------------------------------------
    ' get file contents
    '--------------------------------------
    ff = FreeFile
    If Len(Dir$(fs)) = 0 Then
        Msg fs & " not found."
    Exit Function
    End If
    Try
        Open fs For Binary As #ff
        Get$ #ff, Lof(ff), bs
        Close# ff
    DeVCL %Typ_Object
    Msg "Done"
    Catch
    Msg "Error " & Format$(Err) & " when opening: """ & fs & """"
    End Try
End Function
'**************************************
